@echo off
::
:: Lines beginning with "::" are inactive.
::
::-@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@-<
::
:: Purpose:
:: ~~~~~~~~
:: This batch program is a menu-driven frontend for Franck Uberto's fabulous
:: DOS/Win9x RAM disk utility...XMSDSK (v1.9i).
::
::-------------------------------------------------------------------------<
::
:: Requirements:
:: ~~~~~~~~~~~~~
:: * MS-DOS [ ] Protected-mode ... (with Win9x ... running)
::          [*] Real-mode ........ (with Win9x NOT running)
:: * MS-DOS External Command Program(s):
::   -   CHOICE.COM
::   -     FIND.EXE
::   -    HIMEM.SYS (loaded [DEVICE=C:\WINDOWS\HIMEM.SYS] in CONFIG.SYS)
::   -    LABEL.EXE
::   -      MEM.EXE
::   -     MODE.COM
::   - BATCHMAN.COM (v1.1) (by Michael J Mefford)
::                  (MD5:  753c4c21960b59f5f59ad7e147ff081d  BATCHMAN.COM)
::                  ftp://ftp.elf.stuba.sk/pub/pc/utiltask/batchman.zip
::   -   XMSDSK.EXE (v1.9i) (by Franck Uberto)
::                  (MD5:  e82abe72e3e9448734025bef1eea34ad  XMSDSK.EXE)
::                  ftp://ftp.elf.stuba.sk/pub/pc/utildisk/fu_rd19i.zip
:: * OTHER:
::   -  LASTDRIVE=Z (line must be present in CONFIG.SYS file)
::   -      RFN.BAT (v1.3) (Blaware)
::                  (MD5:  a63883b359464e913d1704fa246ccadf  RFN.BAT)
::                  Requires:  MD5SUM.EXE / NSET.COM (v2.1)
::
::-------------------------------------------------------------------------<
::
:: Overview:
:: ~~~~~~~~~
:: When this batch program (9xRamDrv.bat) is CALLed under real-mode MS-DOS
:: (perhaps from the system's AUTOEXEC.BAT file), the user is offered the
:: option to access it's menu.  From the menu the user will be able to
:: build a ramdisk configuration for the upcoming computer session.
:: Configurable are:
::
::      * SIZE
::      * DRIVE LETTER
::      * DSUF1BF (disk space used for 1-byte file)
::
:: If the user does not access the menu, the program will either auto-abort
:: or auto-install a default ramdisk configuration (must be setup to do so).
::
::-------------------------------------------------------------------------<
::
:: Setup For RamDrive Auto-Install:
:: ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
:: This batch program can be setup to automatically install a default,
:: user-defined ramdrive at each computer restart.  The user can define
:: defaults for the SIZE, DRIVE LETTER, and DSUF1BF (disk space used for
:: 1-byte file).  Any or all of these 3 categories can be set for default by
:: the user; however, for an auto-install to be carried out the "SIZE" must
:: be defined.  Of course, the defaults can be overridden by the user simply
:: by accessing the menu and changing the configuration for that particular
:: computer session.
::
:: To setup this batch program to automatically install a ramdrive at each
:: computer restart, simply "CALL" it with 3 parameters (in proper order):
::
::
::      [CALL 9xRamDrv.bat DRIVE LETTER DSUF1BF SIZE]
::                         ~~~~~~~~~~~~ ~~~~~~~ ~~~~
::
:: Using "#" as a parameter for any of the 3 categories will leave it
:: undefined.  If this is the case, the XMSDSK default will then be used.
:: (Of course, there is no XMSDSK default for the "SIZE" category.)
::
::- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -<
::
:: Examples:
:: ---------
:: 1) To auto-install at each computer restart a 1GB ramdrive as drive J: on
::    which a 1-byte file takes up 32,768 bytes:
::
::      [CALL Drive:\PATH\to\9xRamDrv.bat J 64 1000]
::
:: 2) To auto-install at each computer restart a 1MB ramdrive as drive Q: on
::    which a 1-byte file takes up 512 bytes:
::
::      [caLL i:\pATH_tO\9XRAMDRV.BAT q # 0001]
::
:: 3) To auto-install at each computer restart a 200MB ramdrive with an
::    XMSDSK default drive letter assignment on which a 1-byte file takes up
::    4,096 bytes:
::
::      [CALL 9xRamDrv # 2 0200]
::
::    Explanation:  Since 2 (representing 1,024 bytes and unavailable at
::    200MB) is the defined parameter for DSUF1BF, the XMSDSK default for
::    200MB (4,096 bytes) ends up being used instead.
::
:: 4) To set drive letter P and a DSUF1BF of 16,384 bytes as menu defaults
::    (with no auto-install):
::
::      [call 9xramdrv.BAT P 32 #]
::
:: Of course, CALLing (9xRamDrv.bat) with no parameters will still offer
:: the user access to the 9x RamDrive menu (with XMSDSK default settings
:: displayed initially, rather than custom user defaults).
::
:: Please read the section immediately below to see acceptable values for
:: the 3 (SIZE, DRIVE LETTER, and DSUF1BF) parameters.
::
::- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -<
::
:: DSUF1BF (Disk Space Used For 1-Byte File):
:: ------------------------------------------
::
::                +-------------------------------------------------------+
::                |                                                       |
::                |  AVAILABILITY CHART: DISK SPACE USED FOR 1-BYTE FILE  |
::                |                                                       |
::      +---------+-------------------------------------------------------|
::      | DSUF1BF |       |       |       |       |       |       |       |
::      | (Bytes) | 32768 | 16384 |  8192 |  4096 |  2048 |  1024 |   512 |
::    +-----------+-------+-------+-------+-------+-------+-------+-------|
::    | PARAMETER |       |       |       |       |       |       |       |
::    |     VALUE |   64  |   32  |   16  |   8   |   4   |   2   |       |
:: +==============+=======+=======+=======+=======+=======+=======+=======|
:: | RAMDISK SIZE |       |       |       |       |       |       |       |
:: |         (MB) |       |       |       |       |       |       |       |
:: |--------------+-------+-------+-------+-------+-------+-------+-------|
:: |  1050 - 1950 |   #   |       |       |       |       |       |       |
:: |--------------+-------+-------+-------+-------+-------+-------+-------|
:: |  0550 - 1000 |   *   |   #   |       |       |       |       |       |
:: |--------------+-------+-------+-------+-------+-------+-------+-------|
:: |  0300 - 0500 |   *   |   *   |   #   |       |       |       |       |
:: |--------------+-------+-------+-------+-------+-------+-------+-------|
:: |  0150 - 0250 |   *   |   *   |   *   |   #   |       |       |       |
:: |--------------+-------+-------+-------+-------+-------+-------+-------|
:: |  0064 - 0100 |   *   |   *   |   *   |   *   |   #   |       |       |
:: |--------------+-------+-------+-------+-------+-------+-------+-------|
:: |  0032 - 0060 |   *   |   *   |   *   |   *   |   *   |   #   |       |
:: |--------------+-------+-------+-------+-------+-------+-------+-------|
:: |  0016 - 0028 |   *   |   *   |   #   |   *   |   *   |   *   |       |
:: |--------------+-------+-------+-------+-------+-------+-------+-------|
:: |  0008 - 0012 |   *   |   *   |   *   |   #   |   *   |   *   |       |
:: |--------------+-------+-------+-------+-------+-------+-------+-------|
:: |         0004 |   *   |   *   |   *   |   *   |   #   |   *   |       |
:: |--------------+-------+-------+-------+-------+-------+-------+-------|
:: |         0002 |   *   |   *   |   *   |   *   |   *   |   #   |       |
:: |--------------+-------+-------+-------+-------+-------+-------+-------|
:: |         0001 |   *   |   *   |   *   |   *   |   *   |   *   |   #   |
:: +--------------+-------------------------------------------------------|
::                | KEY:                                                  |
::                | ~~~~                                                  |
::                | # = Available & XMSDSK Default                        |
::                | * = Available                                         |
::                +-------------------------------------------------------+
::
:: 32768 is likely fastest, but could produce most wasted space.
:: 00512 is likely slowest, but could produce least wasted space.
::
:: Of course, the size of the files being read/written will have an affect
:: on the speed that is ultimately realized.
::
::
:: SIZE:
:: -----
::
:: +-------------------------------------------------------+
:: |             AVAILABILITY CHART: SIZE (MB)             |
:: |-------------------------------------------------------|
:: | 1950 | 1550 | 1150 | 0750 | 0350 | 0088 | 0056 | 0024 |
:: | 1900 | 1500 | 1100 | 0700 | 0300 | 0084 | 0052 | 0020 |
:: | 1850 | 1450 | 1050 | 0650 | 0250 | 0080 | 0048 | 0016 |
:: | 1800 | 1400 | 1000 | 0600 | 0200 | 0076 | 0044 | 0012 |
:: | 1750 | 1350 | 0950 | 0550 | 0150 | 0072 | 0040 | 0008 |
:: | 1700 | 1300 | 0900 | 0500 | 0100 | 0068 | 0036 | 0004 |
:: | 1650 | 1250 | 0850 | 0450 | 0096 | 0064 | 0032 | 0002 |
:: | 1600 | 1200 | 0800 | 0400 | 0092 | 0060 | 0028 | 0001 |
:: +-------------------------------------------------------+
::
::
:: DRIVE LETTER:
:: -------------
::
:: +---------------------------------------------------+
:: |         AVAILABILITY CHART: DRIVE LETTER          |
:: |---------------------------------------------------|
:: | A | B | C | D | E | F | G | H | I | J | K | L | M |
:: |---+---+---+---+---+---+---+---+---+---+---+---+---|
:: | N | O | P | Q | R | S | T | U | V | W | X | Y | Z |
:: +---------------------------------------------------+
::
:: Though available, A, B, and C are not highly recommended (duh!).
::
::-------------------------------------------------------------------------<
::
:: Notes:
:: ~~~~~~
:: * This batch code must be run in a real-mode DOS environment (with
::   Windows NOT running).
::
:: * The maximum amount of RAM that can be accessed by XMSDSK is 2GB.  9x
::   RamDrive has not been tested for behavior on a system with more than
::   2GB of installed RAM.
::
:: * The amount of RAM displayed on the SIZE menu, for example...
::        "RAM : 0,512,nnn,nnn Bytes"
::   ...shows the total amount of "available" RAM [in bytes (not megabytes),
::   with the last 6 digits of the total dropped (thus "nnn,nnn")] at the
::   time (current) of the XMSDSK probe.  It does not, then, (necessarily)
::   represent the actual total amount of RAM installed in the system.
::
:: * If problems are encountered running (9xRamDrv.bat), it may be that a
::   larger environment space is needed for it to operate in.  Evidence of
::   this could be "Bad command or file name" errors or menus not displaying
::   properly.  Try running (9xRamDrv.bat) with a command such as:
::        [COMMAND C:\PATH\TO /E:nnnnn /C Q:\PATH\TO\9XRAMDRV.BAT # # #]
::   ("nnnnn" must be between 256 and 32768).  Bla recommends 32768 for
::   nnnnn, as this would provide the maximum space of 32,768 bytes.
::   Alternately, add a line to the system's (CONFIG.SYS) file, such as:
::        [SHELL=C:\PATH\TO\COMMAND.COM /E:32768 /P]
::   This would apply the maximum environment space of 32,768 bytes
::   globally, so that all DOS batch programs would have access to the large
::   environment space automatically.  (BTW, the default environment size is
::   just 256 bytes!)
::
:: * It is assumed that the user intends to use the ramdrive from within a
::   Windows (9x) environment.  Therefore, this batch code "auto-reserves"
::   a minimum of 46MB or 30MB of RAM (for Win98 and Win95, respectively)
::   for the system.  The "Show RECOMMENDED Sizes Only" vs. "Show ALL Sizes"
::   option is there for this purpose--just to sort of shield the
::   non-technical user from unknowingly allocating too much RAM for the
::   ramdrive and thus bogging down the system.  Anyway, if the total amount
::   of available RAM prohibits reserving this amount, then only a 1MB
::   ramdrive is offered for installation (still, choose to "Show ALL Sizes"
::   to pick from the full selection).
::
::   Also, though, the user may edit this batch code as he/she/it wishes!
::   If there is the desire to change, within this batch code, the amount of
::   RAM reserved for the system, see the file:  (Editing.txt).  This will
::   only have an affect on the sizes offered on the "RECOMMENDED Sizes"
::   menu.
::
:: * As far as the Sector/Cluster-related "DSUF1BF" (disk space used for
::   1-byte file) is concerned...
::
::      | BTW, "DSUF1BF" is by no means a common or accepted term, just an
::      | extremely awkward "Bla" term (not proud).
::
::   ...the highest number (32768 bytes) is generally most beneficial for
::   modern day computing.  Lower numbers (16384/8192/4096/2048/1024/512)
::   should really only be considered if the bulk of the files on the
::   ramdrive are projected to be of size 16KB or smaller.
::
:: * Though (HIMEM.SYS) is listed in "Requirements", another XMS memory
::   manager may work just fine.  See (fu_rd19i.zip\Readme.txt) for more
::   information on this topic.
::
:: * If the system's (CONFIG.SYS) file already has a "LASTDRIVE" line in it
::   (different than the recommended "LASTDRIVE=Z") and changing it is not
::   an attractive option, then consider editing the code of (9xRamDrv.bat).
::   Just change the "Z" in the following lines (at LABEL :1G)...
::
::        ---------------------------------------------
::        xmsdsk 3000000 Z: /t /y > NUL
::        type NUL > Z:\$A.TMP
::        dir Z: /-v | find "bytes free" >> #nv#l#d.bat
::        ---------------------------------------------
::
::   ...to whatever drive letter is appropriate.  Actually any unoccupied,
::   potentially valid, drive letter (NOT "B") should work for a ramdrive
::   (if it's below the "LASTDRIVE" letter).  (And then, of course, don't
::   attempt to assign a "higher than LASTDRIVE letter" to a ramdrive.)
::
:: * For official documentation on XMSDSK.EXE (v1.9i), see the file:
::   (fu_rd19i.zip\Readme.txt).
::
:: * (9xRamDrv.bat) was partially adapted from code found here:
::        http://www.ericphelps.com/
::
::-------------------------------------------------------------------------<
::
:: About:                                               (06-13-2009)
:: ~~~~~~
:: 9XRAMDRV.BAT (v1.3) is Blaware, and Blaware is freeware!
::
::      Bla
::      P.O. Box NUL
::      Valley View, Ohio 44125 USA
::
::      E-Mail:   Blaware@FastMail.fm
::      Webpage:  http://www.NUL.nul/index.html
::
:: Feed the birds.  (Why?)  Well, they haven't pecked your eyes out!
::
::-#######################################################################-<
::
ctty nul
echo z | find "z" > NUL
batchman month
if not errorlevel 1 goto 6Y
batchman cls 00h
for %%A in (Z9 Z8 Z6 Z5 Z4 Z2 Z1 Z0 X7 T9 T8) do set %%A=
mode | find "Status for device CON:" > NUL
if errorlevel 1 goto 0K
mode | find "Columns=80" > NUL
if errorlevel 1 goto 0G
set Z9=80
goto 0H
:0G
mode | find "Columns=40" > NUL
if errorlevel 1 goto 0H
set Z9=40
:0H
mode | find "Lines=25" > NUL
if errorlevel 1 goto 0I
set Z8=25
goto 0K
:0I
mode | find "Lines=50" > NUL
if errorlevel 1 goto 0J
set Z8=50
goto 0K
:0J
mode | find "Lines=43" > NUL
if errorlevel 1 goto 0K
set Z8=43
:0K
mem /module:win | find "K)  " > NUL
if errorlevel 1 goto 0L
mem /module:vmm32 | find "K)  " > NUL
if errorlevel 1 goto 0L
goto 6Z
:0L
ver | find "Windows 95" > NUL
if not errorlevel 1 goto 0M
ver | find "Windows 98" > NUL
if not errorlevel 1 goto 0N
goto 7G
:0M
set Z7=95
goto 0O
:0N
set Z7=98
:0O
md5sum -b nuL | find "d41d8cd98f00b204e9800998ecf8427e *nuL" > NUL
if errorlevel 1 set Z6=MD5SUM.EXE
if not .%Z6%.==.. set Z5=.                
if not .%Z6%.==.. goto 0P
nset /? | find "NSET 2.1 (c) 1997 Horst Schaeffer" > NUL
if errorlevel 1 set Z6=NSET.COM (v2.1)
if not .%Z6%.==.. set Z5=.           
if not .%Z6%.==.. goto 0P
xmsdsk /? | find "(v1.9I - 08/98)" > NUL
if errorlevel 1 set Z6=XMSDSK.EXE (v1.9i)
if not .%Z6%.==.. set Z5=.        
if not .%Z6%.==.. goto 0P
c:
cd \
CALL RFN.BAT 8 i w
if .%RFN%.==.. set Z6=RFN.BAT (v1.3)
if not .%Z6%.==.. set Z5=.            
if not .%Z6%.==.. goto 0P
:0P
ctty con
if not .%Z6%.==.. goto 7H
if .%Z9%%Z8%.==.8025. goto 0Q
mode con: cols=80 lines=25
:0Q
batchman numlock on
cls
echo  Ŀ
echo                                                                          
echo                                              
echo                                            
echo                                             
echo                                                                             
echo                                                                              
echo    PRE MENU                                                                  
echo                                                                      
echo                                                                              
batchman cecho c 07h,   Press [
batchman cecho c 0Fh,0
batchman cecho c 07h,] (
batchman cecho c 0Fh,number ZERO
batchman cecho 07h,) to access 9x RamDrive.                            
echo                                                                              
echo    Auto-ABORT in 5 seconds.                                                  
echo                                                                              
echo                                                                              
echo                                                                              
echo                                                                              
echo                                                                              
echo                                                                              
echo                                                                              
echo                                                                              
echo                                                                              
echo  
batchman cecho c 07h,    Type your choice ... [
batchman cecho c 0Fh,0
batchman cecho 07h,]
batchman setcursor 26,01
choice /c:0.123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ!#$&'()-@^_,=+;[]`{}~"*:?\ /n /t:.,7 > NUL
cls
if errorlevel 2 if not .%3.==.. set Z4=#
if .%Z4%.==.#. goto 0R
if errorlevel 2 goto 7K
set Z4=*
:0R
if .%3.==.. goto 0T
if .%Z4%.==.#. if .%3.==.#. goto 7K
if .%3.==.#. goto 0T
for %%B in (0001 0002 0004 0008 0012 0016 0020 0024 0028 0032 0036 0040 0044 0048 0052 0056) do if .%3.==.%%B. goto 0S
for %%C in (0060 0064 0068 0072 0076 0080 0084 0088 0092 0096 0100 0150 0200 0250 0300 0350) do if .%3.==.%%C. goto 0S
for %%D in (0400 0450 0500 0550 0600 0650 0700 0750 0800 0850 0900 0950 1000 1050 1100 1150) do if .%3.==.%%D. goto 0S
for %%E in (1200 1250 1300 1350 1400 1450 1500 1550 1600 1650 1700 1750 1800 1850 1900 1950) do if .%3.==.%%E. goto 0S
if .%Z4%.==.#. goto 7K
goto 0T
:0S
set Z3=%3
:0T
if .%2.==.. goto 0V
if .%2.==.#. goto 0V
for %%F in (64 32 16 8 4 2) do if .%2.==.%%F. goto 0U
goto 0V
:0U
if .%2.==.64. set Z2=32768
if .%2.==.32. set Z2=16384
if .%2.==.16. set Z2=08192
if .%2.==.8. set Z2=04096
if .%2.==.4. set Z2=02048
if .%2.==.2. set Z2=01024
:0V
if .%1.==.. goto 0X
if .%Z4%.==.#. if .%1.==.#. goto 3N
if .%1.==.#. goto 0X
for %%G in (A B C D E F G H I J K L M N O P Q R S T U V W X Y Z) do if .%1.==.%%G. goto 0W
for %%H in (a b c d e f g h i j k l m n o p q r s t u v w x y z) do if .%1.==.%%H. goto 0W
if .%Z4%.==.#. goto 3N
goto 0X
:0W
set Z1=%1
if .%Z4%.==.#. goto 3N
:0X
if not .%Z1%.==.. set Z0=: (User Chosen) 
if .%Z1%.==.. set Z0=XMSDSK Default) 
echo .%Z0%. | find ":" > NUL
if errorlevel 1 set Z1=(
if not .%Z3%.==.. goto %Z3%
:0Y
batchman cls 0Fh
echo  Ŀ
echo                                                                           
echo                                              
echo                                             
echo                                               
echo                                                                             
echo                                                                              
echo                                                                              
batchman cecho c 0Fh, 
batchman cecho c 0Eh,    
batchman cecho 0Fh,                                                                
batchman cecho c 0Fh, 
batchman cecho c 0Eh,                     
batchman cecho 0Fh,            
batchman cecho c 0Fh, 
batchman cecho c 0Eh,                 
batchman cecho 0Fh,            
batchman cecho c 0Fh, 
batchman cecho c 0Eh,                
batchman cecho 0Fh,           
batchman cecho c 0Fh, 
batchman cecho c 0Eh,          
batchman cecho 0Fh,           
batchman cecho c 0Fh, 
batchman cecho c 0Eh,           
batchman cecho 0Fh,           
batchman cecho c 0Fh, 
batchman cecho c 0Eh,           
batchman cecho 0Fh,           
batchman cecho c 0Fh, 
batchman cecho c 0Eh,           
batchman cecho 0Fh,           
batchman cecho c 0Fh, 
batchman cecho c 0Eh,        
batchman cecho 0Fh,           
batchman cecho c 0Fh, 
batchman cecho c 0Eh,           
batchman cecho 0Fh,  
batchman cecho c 0Fh, 
batchman cecho c 0Eh,             
batchman cecho 0Fh,  
batchman cecho c 0Fh, 
batchman cecho c 0Eh,                       
batchman cecho 0Fh,  
echo                                                                              
echo                                                                              
echo  
batchman setcursor 26,01
for %%I in (X2 X1 X0 W9 W7 W6 W5 W4 W3 W2) do set %%I=0
if .%X7%.==.*. goto 1L
if .%X7%.==.#. goto 1K
md %RFN%
cd %RFN%
:0Z
for %%J in (Y7 Y5 Y4 Y3 Y2 Y1 Y0) do set %%J=
set Y9=%Y9%#
mode = > #nv#l#d.bat
if .%Y9%.==.##. goto 1G
xmsdsk 3000000 Z: /t /y > NUL
type NUL > Z:\$A.TMP
dir Z: /-v | find "bytes free" >> #nv#l#d.bat
xmsdsk /u /y > NUL
goto 1H
:1G
echo = | choice /c=%X9%= >> #nv#l#d.bat
:1H
set Y8=
set Y7=%Y7%#
if .%Y7%.==.#. set Y6=3
if .%Y7%.==.##. set Y6=4
if .%Y7%.==.###. set Y6=5
if .%Y7%.==.####. set Y6=6
if .%Y7%.==.#####. set Y6=7
if .%Y7%.==.######. set Y6=8
if .%Y7%.==.#######. set Y6=9
echo set Y8=%%%Y6%> Invalid.bat
call #nv#l#d.bat
if .%Y8%.==.bytes. if .%Y6%.==.9. set Y5=#
if .%Y8%.==.bytes. goto 1I
if .%Y8%.==.]?. goto 1J
if .%Y6%.==.3. set Y4=%Y8%
if .%Y6%.==.4. set Y3=%Y8%
if .%Y6%.==.5. set Y2=%Y8%
if .%Y6%.==.6. set Y1=%Y8%
if .%Y6%.==.7. set Y0=%Y8%
goto 1H
:1I
if .%Y5%.==.. set X9=%Y2%
if not .%Y5%.==.. set X9=%Y2%%Y1%
goto 0Z
:1J
del ?nv?l?d.bat
cd ..
rd %RFN%
if .%Y0%.==.. set X8=1
if .%Y1%.==.. set X8=2
if .%Y2%.==.. set X8=3
if .%X8%.==.1. set Y0=%Y1%
if .%X8%.==.1. set Y1=%Y2%
if .%X8%.==.1. set Y2=%Y3%
if .%X8%.==.1. set Y3=0
if .%X8%.==.2. set Y0=%Y2%
if .%X8%.==.2. set Y1=%Y3%
if .%X8%.==.2. set Y2=0
if .%X8%.==.2. set Y3=0
if .%X8%.==.3. set Y0=%Y3%
if .%X8%.==.3. set Y1=0
if .%X8%.==.3. set Y2=0
if .%X8%.==.3. set Y3=0
for %%K in (Y9 Y8 Y7 Y6 Y4 X8) do set %%K=
:1K
for %%L in (W8 V7) do set %%L=
set X7=*
set X6=Fh,                                      [+]...(
set X5=Bh,Show ALL Sizes
set X4=Dh, RECOMMENDED Sizes
set X3=Fh,    
if .%Z7%.==.98. goto 1M
if .%Z7%.==.95. goto 1N
:1L
for %%M in (W8 V7) do set %%M=
set X7=#
set X6=Fh,                          [+]..(
set X5=Bh,Show RECOMMENDED Sizes Only
set X4=Dh,     ALL Sizes
set X3=Fh,        
for %%N in (X2 X1) do set %%N=0
goto 1S
:1M
set X2=4
set X1=6
goto 1O
:1N
set X2=3
set X1=0
:1O
if .%X2%%X1%.==.00. goto 1S
if .%X0%.==.9. goto 1P
if .%X0%.==.8. set X0=9
if .%X0%.==.7. set X0=8
if .%X0%.==.6. set X0=7
if .%X0%.==.5. set X0=6
if .%X0%.==.4. set X0=5
if .%X0%.==.3. set X0=4
if .%X0%.==.2. set X0=3
if .%X0%.==.1. set X0=2
if .%X0%.==.0. set X0=1
goto 1Q
:1P
set X0=0
if .%W9%.==.4. set W9=5
if .%W9%.==.3. set W9=4
if .%W9%.==.2. set W9=3
if .%W9%.==.1. set W9=2
if .%W9%.==.0. set W9=1
:1Q
if .%Z7%.==.98. if .%W9%%X0%.==.48. goto 1R
if .%Z7%.==.95. if .%W9%%X0%.==.32. goto 1R
if .00%W9%%X0%.==.%Y3%%Y2%%Y1%%Y0%. set W8=0001
if .%W8%.==.. goto 1O
:1R
if not .%W8%.==.. goto 2I
for %%O in (X0 W9) do set %%O=
:1S
if .%X1%.==.9. goto 1T
if .%X1%.==.8. set X1=9
if .%X1%.==.7. set X1=8
if .%X1%.==.6. set X1=7
if .%X1%.==.5. set X1=6
if .%X1%.==.4. set X1=5
if .%X1%.==.3. set X1=4
if .%X1%.==.2. set X1=3
if .%X1%.==.1. set X1=2
if .%X1%.==.0. set X1=1
goto 1W
:1T
set X1=0
if .%X2%.==.9. goto 1U
if .%X2%.==.8. set X2=9
if .%X2%.==.7. set X2=8
if .%X2%.==.6. set X2=7
if .%X2%.==.5. set X2=6
if .%X2%.==.4. set X2=5
if .%X2%.==.3. set X2=4
if .%X2%.==.2. set X2=3
if .%X2%.==.1. set X2=2
if .%X2%.==.0. set X2=1
goto 1W
:1U
set X2=0
if .%W7%.==.9. goto 1V
if .%W7%.==.8. set W7=9
if .%W7%.==.7. set W7=8
if .%W7%.==.6. set W7=7
if .%W7%.==.5. set W7=6
if .%W7%.==.4. set W7=5
if .%W7%.==.3. set W7=4
if .%W7%.==.2. set W7=3
if .%W7%.==.1. set W7=2
if .%W7%.==.0. set W7=1
goto 1W
:1V
set W7=0
if .%W6%.==.1. set W6=2
if .%W6%.==.0. set W6=1
:1W
if .%W5%.==.9. goto 1X
if .%W5%.==.8. set W5=9
if .%W5%.==.7. set W5=8
if .%W5%.==.6. set W5=7
if .%W5%.==.5. set W5=6
if .%W5%.==.4. set W5=5
if .%W5%.==.3. set W5=4
if .%W5%.==.2. set W5=3
if .%W5%.==.1. set W5=2
if .%W5%.==.0. set W5=1
goto 2G
:1X
set W5=0
if .%W4%.==.9. goto 1Y
if .%W4%.==.8. set W4=9
if .%W4%.==.7. set W4=8
if .%W4%.==.6. set W4=7
if .%W4%.==.5. set W4=6
if .%W4%.==.4. set W4=5
if .%W4%.==.3. set W4=4
if .%W4%.==.2. set W4=3
if .%W4%.==.1. set W4=2
if .%W4%.==.0. set W4=1
goto 2G
:1Y
set W4=0
if .%W3%.==.9. goto 1Z
if .%W3%.==.8. set W3=9
if .%W3%.==.7. set W3=8
if .%W3%.==.6. set W3=7
if .%W3%.==.5. set W3=6
if .%W3%.==.4. set W3=5
if .%W3%.==.3. set W3=4
if .%W3%.==.2. set W3=3
if .%W3%.==.1. set W3=2
if .%W3%.==.0. set W3=1
goto 2G
:1Z
set W3=0
if .%W2%.==.1. set W2=2
if .%W2%.==.0. set W2=1
:2G
if .%W2%%W3%%W4%%W5%.==.0002. set W8=0001
if .%W2%%W3%%W4%%W5%.==.0003. set W8=0002
if .%W2%%W3%%W4%%W5%.==.0005. set W8=0004
if .%W2%%W3%%W4%%W5%.==.0009. set W8=0008
if .%W2%%W3%%W4%%W5%.==.0013. set W8=0012
if .%W2%%W3%%W4%%W5%.==.0017. set W8=0016
if .%W2%%W3%%W4%%W5%.==.0021. set W8=0020
if .%W2%%W3%%W4%%W5%.==.0026. set W8=0024
if .%W2%%W3%%W4%%W5%.==.0030. set W8=0028
if .%W2%%W3%%W4%%W5%.==.0034. set W8=0032
if .%W2%%W3%%W4%%W5%.==.0038. set W8=0036
if .%W2%%W3%%W4%%W5%.==.0042. set W8=0040
if .%W2%%W3%%W4%%W5%.==.0047. set W8=0044
if .%W2%%W3%%W4%%W5%.==.0051. set W8=0048
if .%W2%%W3%%W4%%W5%.==.0055. set W8=0052
if .%W2%%W3%%W4%%W5%.==.0059. set W8=0056
if .%W2%%W3%%W4%%W5%.==.0063. set W8=0060
if .%W2%%W3%%W4%%W5%.==.0068. set W8=0064
if .%W2%%W3%%W4%%W5%.==.0072. set W8=0068
if .%W2%%W3%%W4%%W5%.==.0076. set W8=0072
if .%W2%%W3%%W4%%W5%.==.0080. set W8=0076
if .%W2%%W3%%W4%%W5%.==.0084. set W8=0080
if .%W2%%W3%%W4%%W5%.==.0089. set W8=0084
if .%W2%%W3%%W4%%W5%.==.0093. set W8=0088
if .%W2%%W3%%W4%%W5%.==.0097. set W8=0092
if .%W2%%W3%%W4%%W5%.==.0101. set W8=0096
if .%W2%%W3%%W4%%W5%.==.0105. set W8=0100
if .%W2%%W3%%W4%%W5%.==.0158. set W8=0150
if .%W2%%W3%%W4%%W5%.==.0210. set W8=0200
if .%W2%%W3%%W4%%W5%.==.0263. set W8=0250
if .%W2%%W3%%W4%%W5%.==.0315. set W8=0300
if .%W2%%W3%%W4%%W5%.==.0368. set W8=0350
if .%W2%%W3%%W4%%W5%.==.0420. set W8=0400
if .%W2%%W3%%W4%%W5%.==.0472. set W8=0450
if .%W2%%W3%%W4%%W5%.==.0525. set W8=0500
if .%W2%%W3%%W4%%W5%.==.0577. set W8=0550
if .%W2%%W3%%W4%%W5%.==.0630. set W8=0600
if .%W2%%W3%%W4%%W5%.==.0682. set W8=0650
if .%W2%%W3%%W4%%W5%.==.0735. set W8=0700
if .%W2%%W3%%W4%%W5%.==.0787. set W8=0750
if .%W2%%W3%%W4%%W5%.==.0839. set W8=0800
if .%W2%%W3%%W4%%W5%.==.0892. set W8=0850
if .%W2%%W3%%W4%%W5%.==.0944. set W8=0900
if .%W2%%W3%%W4%%W5%.==.0997. set W8=0950
if .%W2%%W3%%W4%%W5%.==.1049. set W8=1000
if .%W2%%W3%%W4%%W5%.==.1102. set W8=1050
if .%W2%%W3%%W4%%W5%.==.1154. set W8=1100
if .%W2%%W3%%W4%%W5%.==.1206. set W8=1150
if .%W2%%W3%%W4%%W5%.==.1259. set W8=1200
if .%W2%%W3%%W4%%W5%.==.1311. set W8=1250
if .%W2%%W3%%W4%%W5%.==.1364. set W8=1300
if .%W2%%W3%%W4%%W5%.==.1416. set W8=1350
if .%W2%%W3%%W4%%W5%.==.1469. set W8=1400
if .%W2%%W3%%W4%%W5%.==.1521. set W8=1450
if .%W2%%W3%%W4%%W5%.==.1573. set W8=1500
if .%W2%%W3%%W4%%W5%.==.1626. set W8=1550
if .%W2%%W3%%W4%%W5%.==.1678. set W8=1600
if .%W2%%W3%%W4%%W5%.==.1731. set W8=1650
if .%W2%%W3%%W4%%W5%.==.1783. set W8=1700
if .%W2%%W3%%W4%%W5%.==.1836. set W8=1750
if .%W2%%W3%%W4%%W5%.==.1888. set W8=1800
if .%W2%%W3%%W4%%W5%.==.1940. set W8=1850
if .%W2%%W3%%W4%%W5%.==.1993. set W8=1900
if .%W2%%W3%%W4%%W5%.==.2045. set W8=1950
if .%W6%%W7%%X2%%X1%.==.%Y3%%Y2%%Y1%%Y0%. set W1=#
if .%W1%.==.. goto 1S
set W1=
goto 2I
:2H
set W0=%W0%#
if .%W0%.==.#. goto 2J
if .%W0%.==.##. goto 2K
if .%W0%.==.###. goto 2L
if .%W0%.==.####. goto 2M
if .%W0%.==.#####. goto 2N
if .%W0%.==.######. goto 2O
if .%W0%.==.#######. goto 2P
if .%W0%.==.########. goto 2Q
if .%W0%.==.#########. goto 2R
if .%W0%.==.##########. goto 2S
if .%W0%.==.###########. goto 2T
:2I
if .%X7%.==.. goto 0Y
batchman cls 0Fh
echo  Ŀ
echo                                                                             
batchman cecho c 0Fh,                   
batchman cecho c 0Eh,  OS : Windows %Z7%
batchman cecho 0Fh,            
batchman cecho c 0Fh,                 
batchman cecho c 0Eh, RAM : %Y3%,%Y2%%Y1%%Y0%,nnn,nnn Bytes
batchman cecho 0Fh,   
echo                   
echo                                                                              
echo     Options:                                         Ŀ   
batchman cecho c 0Fh, 
batchman cecho c 0Ah,   
batchman cecho c 0Fh,                                         
batchman cecho c 0%X4%
batchman cecho 0%X3%
set V9=0001
set V8=  [.]....1MB                                                             
set V7=%V7%.
goto 2U
:2J
set V9=0002
set V8=  [A]....2MB
set V7=%V7%A
if .%V9%.==.%W8%. set V6=                                                               
if .%V9%.==.%W8%. goto 2U
set V9=0004
set V5=  [B]....4MB
set V7=%V7%B
if .%V9%.==.%W8%. set V6=                                                   
if .%V9%.==.%W8%. goto 2U
set V9=0008
set V4=  [C]....8MB
set V7=%V7%C
if .%V9%.==.%W8%. set V6=                                       
if .%V9%.==.%W8%. goto 2U
set V9=0012
set V3=  [D]...12MB
set V7=%V7%D
if .%V9%.==.%W8%. set V6=                           
if .%V9%.==.%W8%. goto 2U
set V9=0016
set V2=  [E]...16MB
set V7=%V7%E
if .%V9%.==.%W8%. set V6=               
if .%V9%.==.%W8%. goto 2U
set V9=0020
set V1=  [F]...20MB   
set V7=%V7%F
goto 2U
:2K
set V9=0024
set V8=  [G]...24MB
set V7=%V7%G
if .%V9%.==.%W8%. set V6=                                                               
if .%V9%.==.%W8%. goto 2U
set V9=0028
set V5=  [H]...28MB
set V7=%V7%H
if .%V9%.==.%W8%. set V6=                                                   
if .%V9%.==.%W8%. goto 2U
set V9=0032
set V4=  [I]...32MB
set V7=%V7%I
if .%V9%.==.%W8%. set V6=                                       
if .%V9%.==.%W8%. goto 2U
set V9=0036
set V3=  [J]...36MB
set V7=%V7%J
if .%V9%.==.%W8%. set V6=                           
if .%V9%.==.%W8%. goto 2U
set V9=0040
set V2=  [K]...40MB
set V7=%V7%K
if .%V9%.==.%W8%. set V6=               
if .%V9%.==.%W8%. goto 2U
set V9=0044
set V1=  [L]...44MB   
set V7=%V7%L
goto 2U
:2L
set V9=0048
set V8=  [M]...48MB
set V7=%V7%M
if .%V9%.==.%W8%. set V6=                                                               
if .%V9%.==.%W8%. goto 2U
set V9=0052
set V5=  [N]...52MB
set V7=%V7%N
if .%V9%.==.%W8%. set V6=                                                   
if .%V9%.==.%W8%. goto 2U
set V9=0056
set V4=  [O]...56MB
set V7=%V7%O
if .%V9%.==.%W8%. set V6=                                       
if .%V9%.==.%W8%. goto 2U
set V9=0060
set V3=  [P]...60MB
set V7=%V7%P
if .%V9%.==.%W8%. set V6=                           
if .%V9%.==.%W8%. goto 2U
set V9=0064
set V2=  [Q]...64MB
set V7=%V7%Q
if .%V9%.==.%W8%. set V6=               
if .%V9%.==.%W8%. goto 2U
set V9=0068
set V1=  [R]...68MB   
set V7=%V7%R
goto 2U
:2M
set V9=0072
set V8=  [S]...72MB
set V7=%V7%S
if .%V9%.==.%W8%. set V6=                                                               
if .%V9%.==.%W8%. goto 2U
set V9=0076
set V5=  [T]...76MB
set V7=%V7%T
if .%V9%.==.%W8%. set V6=                                                   
if .%V9%.==.%W8%. goto 2U
set V9=0080
set V4=  [U]...80MB
set V7=%V7%U
if .%V9%.==.%W8%. set V6=                                       
if .%V9%.==.%W8%. goto 2U
set V9=0084
set V3=  [V]...84MB
set V7=%V7%V
if .%V9%.==.%W8%. set V6=                           
if .%V9%.==.%W8%. goto 2U
set V9=0088
set V2=  [W]...88MB
set V7=%V7%W
if .%V9%.==.%W8%. set V6=               
if .%V9%.==.%W8%. goto 2U
set V9=0092
set V1=  [X]...92MB   
set V7=%V7%X
goto 2U
:2N
set V9=0096
set V8=  [Y]...96MB
set V7=%V7%Y
if .%V9%.==.%W8%. set V6=                                                               
if .%V9%.==.%W8%. goto 2U
set V9=0100
set V5=  [Z]..100MB
set V7=%V7%Z
if .%V9%.==.%W8%. set V6=                                                   
if .%V9%.==.%W8%. goto 2U
set V9=0150
set V4=  [0]..150MB
set V7=%V7%0
if .%V9%.==.%W8%. set V6=                                       
if .%V9%.==.%W8%. goto 2U
set V9=0200
set V3=  [1]..200MB
set V7=%V7%1
if .%V9%.==.%W8%. set V6=                           
if .%V9%.==.%W8%. goto 2U
set V9=0250
set V2=  [2]..250MB
set V7=%V7%2
if .%V9%.==.%W8%. set V6=               
if .%V9%.==.%W8%. goto 2U
set V9=0300
set V1=  [3]..300MB   
set V7=%V7%3
goto 2U
:2O
set V9=0350
set V8=  [4]..350MB
set V7=%V7%4
if .%V9%.==.%W8%. set V6=                                                               
if .%V9%.==.%W8%. goto 2U
set V9=0400
set V5=  [5]..400MB
set V7=%V7%5
if .%V9%.==.%W8%. set V6=                                                   
if .%V9%.==.%W8%. goto 2U
set V9=0450
set V4=  [6]..450MB
set V7=%V7%6
if .%V9%.==.%W8%. set V6=                                       
if .%V9%.==.%W8%. goto 2U
set V9=0500
set V3=  [7]..500MB
set V7=%V7%7
if .%V9%.==.%W8%. set V6=                           
if .%V9%.==.%W8%. goto 2U
set V9=0550
set V2=  [8]..550MB
set V7=%V7%8
if .%V9%.==.%W8%. set V6=               
if .%V9%.==.%W8%. goto 2U
set V9=0600
set V1=  [9]..600MB   
set V7=%V7%9
goto 2U
:2P
set V9=0650
set V8=  [a]..650MB
set V7=%V7%a
if .%V9%.==.%W8%. set V6=                                                               
if .%V9%.==.%W8%. goto 2U
set V9=0700
set V5=  [b]..700MB
set V7=%V7%b
if .%V9%.==.%W8%. set V6=                                                   
if .%V9%.==.%W8%. goto 2U
set V9=0750
set V4=  [c]..750MB
set V7=%V7%c
if .%V9%.==.%W8%. set V6=                                       
if .%V9%.==.%W8%. goto 2U
set V9=0800
set V3=  [d]..800MB
set V7=%V7%d
if .%V9%.==.%W8%. set V6=                           
if .%V9%.==.%W8%. goto 2U
set V9=0850
set V2=  [e]..850MB
set V7=%V7%e
if .%V9%.==.%W8%. set V6=               
if .%V9%.==.%W8%. goto 2U
set V9=0900
set V1=  [f]..900MB   
set V7=%V7%f
goto 2U
:2Q
set V9=0950
set V8=  [g]..950MB
set V7=%V7%g
if .%V9%.==.%W8%. set V6=                                                               
if .%V9%.==.%W8%. goto 2U
set V9=1000
set V5=  [h].1000MB
set V7=%V7%h
if .%V9%.==.%W8%. set V6=                                                   
if .%V9%.==.%W8%. goto 2U
set V9=1050
set V4=  [i].1050MB
set V7=%V7%i
if .%V9%.==.%W8%. set V6=                                       
if .%V9%.==.%W8%. goto 2U
set V9=1100
set V3=  [j].1100MB
set V7=%V7%j
if .%V9%.==.%W8%. set V6=                           
if .%V9%.==.%W8%. goto 2U
set V9=1150
set V2=  [k].1150MB
set V7=%V7%k
if .%V9%.==.%W8%. set V6=               
if .%V9%.==.%W8%. goto 2U
set V9=1200
set V1=  [l].1200MB   
set V7=%V7%l
goto 2U
:2R
set V9=1250
set V8=  [m].1250MB
set V7=%V7%m
if .%V9%.==.%W8%. set V6=                                                               
if .%V9%.==.%W8%. goto 2U
set V9=1300
set V5=  [n].1300MB
set V7=%V7%n
if .%V9%.==.%W8%. set V6=                                                   
if .%V9%.==.%W8%. goto 2U
set V9=1350
set V4=  [o].1350MB
set V7=%V7%o
if .%V9%.==.%W8%. set V6=                                       
if .%V9%.==.%W8%. goto 2U
set V9=1400
set V3=  [p].1400MB
set V7=%V7%p
if .%V9%.==.%W8%. set V6=                           
if .%V9%.==.%W8%. goto 2U
set V9=1450
set V2=  [q].1450MB
set V7=%V7%q
if .%V9%.==.%W8%. set V6=               
if .%V9%.==.%W8%. goto 2U
set V9=1500
set V1=  [r].1500MB   
set V7=%V7%r
goto 2U
:2S
set V9=1550
set V8=  [s].1550MB
set V7=%V7%s
if .%V9%.==.%W8%. set V6=                                                               
if .%V9%.==.%W8%. goto 2U
set V9=1600
set V5=  [t].1600MB
set V7=%V7%t
if .%V9%.==.%W8%. set V6=                                                   
if .%V9%.==.%W8%. goto 2U
set V9=1650
set V4=  [u].1650MB
set V7=%V7%u
if .%V9%.==.%W8%. set V6=                                       
if .%V9%.==.%W8%. goto 2U
set V9=1700
set V3=  [v].1700MB
set V7=%V7%v
if .%V9%.==.%W8%. set V6=                           
if .%V9%.==.%W8%. goto 2U
set V9=1750
set V2=  [w].1750MB
set V7=%V7%w
if .%V9%.==.%W8%. set V6=               
if .%V9%.==.%W8%. goto 2U
set V9=1800
set V1=  [x].1800MB   
set V7=%V7%x
goto 2U
:2T
set V9=1850
set V8=  [y].1850MB
set V7=%V7%y
if .%V9%.==.%W8%. set V6=                                                               
if .%V9%.==.%W8%. goto 2U
set V9=1900
set V5=  [z].1900MB
set V7=%V7%z
if .%V9%.==.%W8%. set V6=                                                   
if .%V9%.==.%W8%. goto 2U
set V9=1950
set V4=  [*].1950MB                                       
set V7=%V7%*
:2U
if .%V9%.==.%W8%. set W1=#
echo   %V8%%V5%%V4%%V3%%V2%%V1%%V6%
for %%P in (V8 V6 V5 V4 V3 V2 V1) do set %%P=
if not .%W1%.==.. goto 2V
if not .%W0%.==.###########. goto 2H
:2V
set V0= /s
for %%Q in (W1 W0 V9 U9) do set %%Q=
batchman cecho c 0Fh,    [-].ABORT!
batchman cecho c 0%X6%
batchman cecho c 0%X5%
batchman cecho 0Fh,)   
echo                                                                              
echo  
if .%V7%.==..ABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789. set V0=
if .%V7%.==..ABCDEFGHIJKLMNOPQRSTUVWXYZ012345678. set V0=
if .%V7%.==..ABCDEFGHIJKLMNOPQRSTUVWXYZ01234567. set V0=
if .%V7%.==..ABCDEFGHIJKLMNOPQRSTUVWXYZ0123456. set V0=
if .%V7%.==..ABCDEFGHIJKLMNOPQRSTUVWXYZ012345. set V0=
if .%V7%.==..ABCDEFGHIJKLMNOPQRSTUVWXYZ01234. set V0=
if .%V7%.==..ABCDEFGHIJKLMNOPQRSTUVWXYZ0123. set V0=
if .%V7%.==..ABCDEFGHIJKLMNOPQRSTUVWXYZ012. set V0=
if .%V7%.==..ABCDEFGHIJKLMNOPQRSTUVWXYZ01. set V0=
if .%V7%.==..ABCDEFGHIJKLMNOPQRSTUVWXYZ0. set V0=
if .%V7%.==..ABCDEFGHIJKLMNOPQRSTUVWXYZ. set V0=
if .%V7%.==..ABCDEFGHIJKLMNOPQRSTUVWXY. set V0=
if .%V7%.==..ABCDEFGHIJKLMNOPQRSTUVWX. set V0=
if .%V7%.==..ABCDEFGHIJKLMNOPQRSTUVW. set V0=
if .%V7%.==..ABCDEFGHIJKLMNOPQRSTUV. set V0=
if .%V7%.==..ABCDEFGHIJKLMNOPQRSTU. set V0=
if .%V7%.==..ABCDEFGHIJKLMNOPQRST. set V0=
if .%V7%.==..ABCDEFGHIJKLMNOPQRS. set V0=
if .%V7%.==..ABCDEFGHIJKLMNOPQR. set V0=
if .%V7%.==..ABCDEFGHIJKLMNOPQ. set V0=
if .%V7%.==..ABCDEFGHIJKLMNOP. set V0=
if .%V7%.==..ABCDEFGHIJKLMNO. set V0=
if .%V7%.==..ABCDEFGHIJKLMN. set V0=
if .%V7%.==..ABCDEFGHIJKLM. set V0=
if .%V7%.==..ABCDEFGHIJKL. set V0=
if .%V7%.==..ABCDEFGHIJK. set V0=
if .%V7%.==..ABCDEFGHIJ. set V0=
if .%V7%.==..ABCDEFGHI. set V0=
if .%V7%.==..ABCDEFGH. set V0=
if .%V7%.==..ABCDEFG. set V0=
if .%V7%.==..ABCDEF. set V0=
if .%V7%.==..ABCDE. set V0=
if .%V7%.==..ABCD. set V0=
if .%V7%.==..ABC. set V0=
if .%V7%.==..AB. set V0=
if .%V7%.==..A. set V0=
if not .%V0%.==.. set U9= (case sEnSiTiVe)
echo     Type your choice%U9% ... [?]
batchman setcursor 26,01
choice /c:+-%V7% /n%V0% > NUL
if errorlevel 66 goto 1950
if errorlevel 65 goto 1900
if errorlevel 64 goto 1850
if errorlevel 63 goto 1800
if errorlevel 62 goto 1750
if errorlevel 61 goto 1700
if errorlevel 60 goto 1650
if errorlevel 59 goto 1600
if errorlevel 58 goto 1550
if errorlevel 57 goto 1500
if errorlevel 56 goto 1450
if errorlevel 55 goto 1400
if errorlevel 54 goto 1350
if errorlevel 53 goto 1300
if errorlevel 52 goto 1250
if errorlevel 51 goto 1200
if errorlevel 50 goto 1150
if errorlevel 49 goto 1100
if errorlevel 48 goto 1050
if errorlevel 47 goto 1000
if errorlevel 46 goto 0950
if errorlevel 45 goto 0900
if errorlevel 44 goto 0850
if errorlevel 43 goto 0800
if errorlevel 42 goto 0750
if errorlevel 41 goto 0700
if errorlevel 40 goto 0650
if errorlevel 39 goto 0600
if errorlevel 38 goto 0550
if errorlevel 37 goto 0500
if errorlevel 36 goto 0450
if errorlevel 35 goto 0400
if errorlevel 34 goto 0350
if errorlevel 33 goto 0300
if errorlevel 32 goto 0250
if errorlevel 31 goto 0200
if errorlevel 30 goto 0150
if errorlevel 29 goto 0100
if errorlevel 28 goto 0096
if errorlevel 27 goto 0092
if errorlevel 26 goto 0088
if errorlevel 25 goto 0084
if errorlevel 24 goto 0080
if errorlevel 23 goto 0076
if errorlevel 22 goto 0072
if errorlevel 21 goto 0068
if errorlevel 20 goto 0064
if errorlevel 19 goto 0060
if errorlevel 18 goto 0056
if errorlevel 17 goto 0052
if errorlevel 16 goto 0048
if errorlevel 15 goto 0044
if errorlevel 14 goto 0040
if errorlevel 13 goto 0036
if errorlevel 12 goto 0032
if errorlevel 11 goto 0028
if errorlevel 10 goto 0024
if errorlevel 9 goto 0020
if errorlevel 8 goto 0016
if errorlevel 7 goto 0012
if errorlevel 6 goto 0008
if errorlevel 5 goto 0004
if errorlevel 4 goto 0002
if errorlevel 3 goto 0001
if errorlevel 2 goto 7K
if errorlevel 1 goto 0Y
:1950
set Z3=1950
set U8=2
set U7=32768
goto 2W
:1900
set Z3=1900
set U8=2
set U7=32768
goto 2W
:1850
set Z3=1850
set U8=2
set U7=32768
goto 2W
:1800
set Z3=1800
set U8=2
set U7=32768
goto 2W
:1750
set Z3=1750
set U8=2
set U7=32768
goto 2W
:1700
set Z3=1700
set U8=2
set U7=32768
goto 2W
:1650
set Z3=1650
set U8=2
set U7=32768
goto 2W
:1600
set Z3=1600
set U8=2
set U7=32768
goto 2W
:1550
set Z3=1550
set U8=2
set U7=32768
goto 2W
:1500
set Z3=1500
set U8=2
set U7=32768
goto 2W
:1450
set Z3=1450
set U8=2
set U7=32768
goto 2W
:1400
set Z3=1400
set U8=2
set U7=32768
goto 2W
:1350
set Z3=1350
set U8=2
set U7=32768
goto 2W
:1300
set Z3=1300
set U8=2
set U7=32768
goto 2W
:1250
set Z3=1250
set U8=2
set U7=32768
goto 2W
:1200
set Z3=1200
set U8=2
set U7=32768
goto 2W
:1150
set Z3=1150
set U8=2
set U7=32768
goto 2W
:1100
set Z3=1100
set U8=2
set U7=32768
goto 2W
:1050
set Z3=1050
set U8=2
set U7=32768
goto 2W
:1000
set Z3=1000
set U8=3
set U7=16384
goto 2W
:0950
set Z3=0950
set U8=3
set U7=16384
goto 2W
:0900
set Z3=0900
set U8=3
set U7=16384
goto 2W
:0850
set Z3=0850
set U8=3
set U7=16384
goto 2W
:0800
set Z3=0800
set U8=3
set U7=16384
goto 2W
:0750
set Z3=0750
set U8=3
set U7=16384
goto 2W
:0700
set Z3=0700
set U8=3
set U7=16384
goto 2W
:0650
set Z3=0650
set U8=3
set U7=16384
goto 2W
:0600
set Z3=0600
set U8=3
set U7=16384
goto 2W
:0550
set Z3=0550
set U8=3
set U7=16384
goto 2W
:0500
set Z3=0500
set U8=4
set U7=08192
goto 2W
:0450
set Z3=0450
set U8=4
set U7=08192
goto 2W
:0400
set Z3=0400
set U8=4
set U7=08192
goto 2W
:0350
set Z3=0350
set U8=4
set U7=08192
goto 2W
:0300
set Z3=0300
set U8=4
set U7=08192
goto 2W
:0250
set Z3=0250
set U8=5
set U7=04096
goto 2W
:0200
set Z3=0200
set U8=5
set U7=04096
goto 2W
:0150
set Z3=0150
set U8=5
set U7=04096
goto 2W
:0100
set Z3=0100
set U8=6
set U7=02048
goto 2W
:0096
set Z3=0096
set U8=6
set U7=02048
goto 2W
:0092
set Z3=0092
set U8=6
set U7=02048
goto 2W
:0088
set Z3=0088
set U8=6
set U7=02048
goto 2W
:0084
set Z3=0084
set U8=6
set U7=02048
goto 2W
:0080
set Z3=0080
set U8=6
set U7=02048
goto 2W
:0076
set Z3=0076
set U8=6
set U7=02048
goto 2W
:0072
set Z3=0072
set U8=6
set U7=02048
goto 2W
:0068
set Z3=0068
set U8=6
set U7=02048
goto 2W
:0064
set Z3=0064
set U8=6
set U7=02048
goto 2W
:0060
set Z3=0060
set U8=7
set U7=01024
goto 2W
:0056
set Z3=0056
set U8=7
set U7=01024
goto 2W
:0052
set Z3=0052
set U8=7
set U7=01024
goto 2W
:0048
set Z3=0048
set U8=7
set U7=01024
goto 2W
:0044
set Z3=0044
set U8=7
set U7=01024
goto 2W
:0040
set Z3=0040
set U8=7
set U7=01024
goto 2W
:0036
set Z3=0036
set U8=7
set U7=01024
goto 2W
:0032
set Z3=0032
set U8=7
set U7=01024
goto 2W
:0028
set Z3=0028
set U8=7
set U7=08192
goto 2W
:0024
set Z3=0024
set U8=7
set U7=08192
goto 2W
:0020
set Z3=0020
set U8=7
set U7=08192
goto 2W
:0016
set Z3=0016
set U8=7
set U7=08192
goto 2W
:0012
set Z3=0012
set U8=7
set U7=04096
goto 2W
:0008
set Z3=0008
set U8=7
set U7=04096
goto 2W
:0004
set Z3=0004
set U8=7
set U7=02048
goto 2W
:0002
set Z3=0002
set U8=7
set U7=01024
goto 2W
:0001
set Z3=0001
set U8=7
set U7=00512
:2W
if .%U8%.==.7. set U6=34567
if .%U8%.==.7. goto 2X
if .%U8%.==.6. set U6=3456
if .%U8%.==.6. goto 2Y
if .%U8%.==.5. set U6=345
if .%U8%.==.5. goto 2Z
if .%U8%.==.4. set U6=34
if .%U8%.==.4. goto 3G
if .%U8%.==.3. set U6=3
if .%U8%.==.3. goto 3H
if .%U8%.==.2. goto 3I
:2X
set U5=[7] ... 01024 bytes used                      
:2Y
set U4=[6] ... 02048 bytes used                      
:2Z
set U3=[5] ... 04096 bytes used                      
:3G
set U2=[4] ... 08192 bytes used                      
:3H
set U1=[3] ... 16384 bytes used                      
:3I
set U0=[2] ... 32768 bytes used                      
if .%U8%.==.7. goto 3N
if .%U8%.==.6. goto 3M
if .%U8%.==.5. goto 3L
if .%U8%.==.4. goto 3K
if .%U8%.==.3. goto 3J
set U1=                                              
:3J
set U2=                                              
:3K
set U3=                                              
:3L
set U4=                                              
:3M
set U5=                                              
:3N
if .%Z3%.==.1950. set T9=1996800
if .%Z3%.==.1900. set T9=1945600
if .%Z3%.==.1850. set T9=1894400
if .%Z3%.==.1800. set T9=1843200
if .%Z3%.==.1750. set T9=1792000
if .%Z3%.==.1700. set T9=1740800
if .%Z3%.==.1650. set T9=1689600
if .%Z3%.==.1600. set T9=1638400
if .%Z3%.==.1550. set T9=1587200
if .%Z3%.==.1500. set T9=1536000
if .%Z3%.==.1450. set T9=1484800
if .%Z3%.==.1400. set T9=1433600
if .%Z3%.==.1350. set T9=1382400
if .%Z3%.==.1300. set T9=1331200
if .%Z3%.==.1250. set T9=1280000
if .%Z3%.==.1200. set T9=1228800
if .%Z3%.==.1150. set T9=1177600
if .%Z3%.==.1100. set T9=1126400
if .%Z3%.==.1050. set T9=1075200
if .%Z3%.==.1000. set T9=1024000
if .%Z3%.==.0950. set T9=972800
if .%Z3%.==.0900. set T9=921600
if .%Z3%.==.0850. set T9=870400
if .%Z3%.==.0800. set T9=819200
if .%Z3%.==.0750. set T9=768000
if .%Z3%.==.0700. set T9=716800
if .%Z3%.==.0650. set T9=665600
if .%Z3%.==.0600. set T9=614400
if .%Z3%.==.0550. set T9=563200
if .%Z3%.==.0500. set T9=512000
if .%Z3%.==.0450. set T9=460800
if .%Z3%.==.0400. set T9=409600
if .%Z3%.==.0350. set T9=358400
if .%Z3%.==.0300. set T9=307200
if .%Z3%.==.0250. set T9=256000
if .%Z3%.==.0200. set T9=204800
if .%Z3%.==.0150. set T9=153600
if .%Z3%.==.0100. set T9=102400
if .%Z3%.==.0096. set T9=98304
if .%Z3%.==.0092. set T9=94208
if .%Z3%.==.0088. set T9=90112
if .%Z3%.==.0084. set T9=86016
if .%Z3%.==.0080. set T9=81920
if .%Z3%.==.0076. set T9=77824
if .%Z3%.==.0072. set T9=73728
if .%Z3%.==.0068. set T9=69632
if .%Z3%.==.0064. set T9=65536
if .%Z3%.==.0060. set T9=61440
if .%Z3%.==.0056. set T9=57344
if .%Z3%.==.0052. set T9=53248
if .%Z3%.==.0048. set T9=49152
if .%Z3%.==.0044. set T9=45056
if .%Z3%.==.0040. set T9=40960
if .%Z3%.==.0036. set T9=36864
if .%Z3%.==.0032. set T9=32768
if .%Z3%.==.0028. set T9=28672
if .%Z3%.==.0024. set T9=24576
if .%Z3%.==.0020. set T9=20480
if .%Z3%.==.0016. set T9=16384
if .%Z3%.==.0012. set T9=12288
if .%Z3%.==.0008. set T9=8192
if .%Z3%.==.0004. set T9=4096
if .%Z3%.==.0002. set T9=2048
if .%Z3%.==.0001. set T9=1024
if .%Z4%.==.#. goto 5P
goto 5L
:3O
batchman cls 0Fh
echo  Ŀ
echo                                                                           
echo                                              
echo                                             
echo                                               
echo                                                                             
echo                                                                              
echo    DISK SPACE USED FOR 1-BYTE FILE                                           
batchman cecho c 0Fh, 
batchman cecho c 0Eh,  
batchman cecho 0Fh,                                           
echo                                                                              
echo    "Disk Space Used For 1-Byte File" is a (Sector-Cluster) factor thingy.    
echo    Generally, a larger value is faster, while a smaller wastes less space.   
echo                                                                              
echo       Options:                                                               
batchman cecho c 0Fh, 
batchman cecho c 0Ah,     
batchman cecho 0Fh,                                                               
echo       [-] ... ABORT!           %U0%
echo       [1] ... XMSDSK Default   %U1%
echo       [0] ... Cancel           %U2%
echo                                %U3%
echo                                %U4%
echo                                %U5%
echo                                                                              
echo  
echo     Type your choice ... [0-%U8%] [-]
batchman setcursor 26,01
choice /c:012-%U6% /n > NUL
if errorlevel 9 goto 3V
if errorlevel 8 goto 3U
if errorlevel 7 goto 3T
if errorlevel 6 goto 3S
if errorlevel 5 goto 3R
if errorlevel 4 goto 7K
if errorlevel 3 goto 3Q
if errorlevel 2 goto 3P
if errorlevel 1 goto 5L
:3P
set Z2=%U7%
goto 5L
:3Q
set Z2=32768
goto 5L
:3R
set Z2=16384
goto 5L
:3S
set Z2=08192
goto 5L
:3T
set Z2=04096
goto 5L
:3U
set Z2=02048
goto 5L
:3V
set Z2=01024
goto 5L
:3W
batchman cls 0Fh
echo  Ŀ
echo                                                                           
echo                                              
echo                                             
echo                                               
echo                                                                             
echo                                                                              
echo    DRIVE LETTER                                                              
batchman cecho c 0Fh, 
batchman cecho c 0Eh,  
batchman cecho 0Fh,                                                              
echo                                                                              
echo    To change the letter of the RamDrive, type the desired letter.            
echo                                                                              
echo    WARNING:  Changing of the RamDrive letter is done at the user's risk!     
batchman cecho c 0Fh, 
batchman cecho c 0Dh,  ********
batchman cecho 0Fh,                                                                  
echo                                                                              
echo       Options:                                                               
batchman cecho c 0Fh, 
batchman cecho c 0Ah,     
batchman cecho 0Fh,                                                               
echo         [-] ... ABORT!                                                       
echo       [A-Z] ... Desired Drive Letter                                         
echo         [1] ... Default Drive Letter                                         
echo         [0] ... Cancel                                                       
echo                                                                              
echo  
echo     Type your choice ... [0,1] [A-Z] [-]
batchman setcursor 26,01
choice /c:01ABCDEFGHIJKLMNOPQRSTUVWXYZ- /n > NUL
if errorlevel 29 goto 7K
if errorlevel 28 goto 3X
if errorlevel 27 goto 3Y
if errorlevel 26 goto 3Z
if errorlevel 25 goto 4G
if errorlevel 24 goto 4H
if errorlevel 23 goto 4I
if errorlevel 22 goto 4J
if errorlevel 21 goto 4K
if errorlevel 20 goto 4L
if errorlevel 19 goto 4M
if errorlevel 18 goto 4N
if errorlevel 17 goto 4O
if errorlevel 16 goto 4P
if errorlevel 15 goto 4Q
if errorlevel 14 goto 4R
if errorlevel 13 goto 4S
if errorlevel 12 goto 4T
if errorlevel 11 goto 4U
if errorlevel 10 goto 4V
if errorlevel 9 goto 4W
if errorlevel 8 goto 4X
if errorlevel 7 goto 4Y
if errorlevel 6 goto 4Z
if errorlevel 5 goto 5G
if errorlevel 4 goto 5H
if errorlevel 3 goto 5I
if errorlevel 2 goto 5K
if errorlevel 1 goto 5L
:3X
set Z1=Z
goto 5J
:3Y
set Z1=Y
goto 5J
:3Z
set Z1=X
goto 5J
:4G
set Z1=W
goto 5J
:4H
set Z1=V
goto 5J
:4I
set Z1=U
goto 5J
:4J
set Z1=T
goto 5J
:4K
set Z1=S
goto 5J
:4L
set Z1=R
goto 5J
:4M
set Z1=Q
goto 5J
:4N
set Z1=P
goto 5J
:4O
set Z1=O
goto 5J
:4P
set Z1=N
goto 5J
:4Q
set Z1=M
goto 5J
:4R
set Z1=L
goto 5J
:4S
set Z1=K
goto 5J
:4T
set Z1=J
goto 5J
:4U
set Z1=I
goto 5J
:4V
set Z1=H
goto 5J
:4W
set Z1=G
goto 5J
:4X
set Z1=F
goto 5J
:4Y
set Z1=E
goto 5J
:4Z
set Z1=D
goto 5J
:5G
set Z1=C
goto 5J
:5H
set Z1=B
goto 5J
:5I
set Z1=A
goto 5J
:5J
set Z0=: (User Chosen) 
goto 5L
:5K
set Z1=(
set Z0=XMSDSK Default) 
:5L
if .%Z4%.==.*. if .%Z2%.==.. set Z2=%U7%
:5M
set T8=%T8%#
if .%T8%.==.#######. goto 5N
if .%T8%.==.######. set T7=%U0%
if .%T8%.==.#####. set T7=%U1%
if .%T8%.==.####. set T7=%U2%
if .%T8%.==.###. set T7=%U3%
if .%T8%.==.##. set T7=%U4%
if .%T8%.==.#. set T7=%U5%
echo .%T7%. | find "%Z2%" > NUL
if not errorlevel 1 goto 5O
goto 5M
:5N
set Z2=%U7%
:5O
set T8=
if .%Z2%.==.%U7%. set T6=(XMSDSK Default)
if not .%Z2%.==.%U7%. set T6=(User Selection)
for %%R in (Z4 V7 V0 U9) do set %%R=
batchman cls 0Fh
echo  Ŀ
echo                                                                           
echo                                              
echo                                             
echo                                               
echo                                                                             
echo                                                                              
echo    CONFIRMATION                     Ŀ   
batchman cecho c 0Fh, 
batchman cecho c 0Eh,  
batchman cecho c 0Fh,                     
batchman cecho c 0Dh, Size
batchman cecho c 0Fh,            
batchman cecho c 0Dh, %Z3% MB
batchman cecho 0Fh,             
echo                                     ĳĳ   
echo    This session's RamDrive details:  Drive Letter     %Z1%%Z0%   
echo                                     ĳĳ   
batchman cecho c 0Fh,                                    
batchman cecho c 0Bh, Disk Space Used
batchman cecho c 0Fh, 
batchman cecho c 0Bh, %Z2% Bytes
batchman cecho 0Fh,         
batchman cecho c 0Fh,                                    
batchman cecho c 0Bh, For 1-Byte File
batchman cecho c 0Fh, 
batchman cecho c 0Bh, %T6%
batchman cecho 0Fh,    
echo       Options:                         
batchman cecho c 0Fh, 
batchman cecho c 0Ah,     
batchman cecho 0Fh,                                                               
echo       [-] ... ABORT!                                                         
batchman cecho c 0Fh,      [3] ... Change -
batchman cecho c 0Dh, Size
batchman cecho 0Fh,                                                  
echo       [2] ... Change - Drive Letter                                          
batchman cecho c 0Fh,      [1] ... Change -
batchman cecho c 0Bh, Disk Space Used For 1-Byte File
batchman cecho 0Fh,                       
echo       [0] ... OK                                                             
echo                                                                              
echo  
echo     Type your choice ... [0-3] [-]
batchman setcursor 26,01
choice /c:0123- /n > NUL
if errorlevel 5 goto 7K
if errorlevel 4 goto 2I
if errorlevel 3 goto 3W
if errorlevel 2 goto 3O
:5P
echo .%Z0%. | find "X" > NUL
if errorlevel 1 if not .%Z1%.==.. set Z1= %Z1%:
echo .%Z1%. | find ":" > NUL
if errorlevel 1 set Z1=
if .%Z2%.==.%U7%. set Z2=
if .%Z2%.==.. goto 5Q
if .%Z2%.==.32768. set Z2= /c64
if .%Z2%.==.16384. set Z2= /c32
if .%Z2%.==.08192. set Z2= /c16
if .%Z2%.==.04096. set Z2= /c8
if .%Z2%.==.02048. set Z2= /c4
if .%Z2%.==.01024. set Z2= /c2
:5Q
xmsdsk %T9%%Z1%%Z2% /t /y > NUL
if errorlevel 26 goto 5R
if errorlevel 25 goto 5S
if errorlevel 24 goto 5T
if errorlevel 23 goto 5U
if errorlevel 22 goto 5V
if errorlevel 21 goto 5W
if errorlevel 20 goto 5X
if errorlevel 19 goto 5Y
if errorlevel 18 goto 5Z
if errorlevel 17 goto 6G
if errorlevel 16 goto 6H
if errorlevel 15 goto 6I
if errorlevel 14 goto 6J
if errorlevel 13 goto 6K
if errorlevel 12 goto 6L
if errorlevel 11 goto 6M
if errorlevel 10 goto 6N
if errorlevel 9 goto 6O
if errorlevel 8 goto 6P
if errorlevel 7 goto 6Q
if errorlevel 6 goto 6R
if errorlevel 5 goto 6S
if errorlevel 4 goto 6T
if errorlevel 3 goto 6U
if errorlevel 2 goto 6V
if errorlevel 1 goto 6W
:5R
set T5=Z
goto 6X
:5S
set T5=Y
goto 6X
:5T
set T5=X
goto 6X
:5U
set T5=W
goto 6X
:5V
set T5=V
goto 6X
:5W
set T5=U
goto 6X
:5X
set T5=T
goto 6X
:5Y
set T5=S
goto 6X
:5Z
set T5=R
goto 6X
:6G
set T5=Q
goto 6X
:6H
set T5=P
goto 6X
:6I
set T5=O
goto 6X
:6J
set T5=N
goto 6X
:6K
set T5=M
goto 6X
:6L
set T5=L
goto 6X
:6M
set T5=K
goto 6X
:6N
set T5=J
goto 6X
:6O
set T5=I
goto 6X
:6P
set T5=H
goto 6X
:6Q
set T5=G
goto 6X
:6R
set T5=F
goto 6X
:6S
set T5=E
goto 6X
:6T
set T5=D
goto 6X
:6U
set T5=C
goto 6X
:6V
set T5=B
goto 6X
:6W
set T5=A
:6X
label %T5%:RamDrv_%Z3%
md %T5%:\Temp
md %T5%:\User
md %T5%:\User\Folder
>  %T5%:\User\File.txt echo.
>  %T5%:\Readme.txt echo.
>> %T5%:\Readme.txt echo Note:  As stated in the XMSDSK (README.TXT) file, the root directory of this
>> %T5%:\Readme.txt echo ~~~~~  ramdrive has a limit of 512 entries (files and/or folders).  If they
>> %T5%:\Readme.txt echo have long filenames [anything longer than the (8.3) MSDOS standard] then the
>> %T5%:\Readme.txt echo limit is even lower.  So, if working with a large number of files/folders,
>> %T5%:\Readme.txt echo work within a folder where this particular limitation does not apply.     :)
>> %T5%:\Readme.txt echo.
>> %T5%:\Readme.txt echo RamDrive created by:
>> %T5%:\Readme.txt echo XMSDSK.EXE (v1.9i)
>> %T5%:\Readme.txt echo Franck UBERTO - 98/08/12
>> %T5%:\Readme.txt echo 38000 Grenoble - FRANCE
>> %T5%:\Readme.txt echo Email : uberto@esrf.fr
goto 7J
:6Y
ctty con
cls
echo  Ŀ
echo                                                                           
echo                                              
echo                                             
echo                                               
echo                                                                             
echo                                                                           
echo                                                           
echo                                                            
echo                                                              
echo                                                                              
echo                                                                              
echo    There is a problem with the required program:  BATCHMAN.COM (v1.1).       
echo                                                                              
echo    Check that the proper version is installed in one of the system's PATH    
echo                                                                              
echo    directories.                                                              
echo                                                                              
echo                                                                              
echo    THIS program (9xRamDrv.bat) must now abort!                               
echo                                                                          :(  
echo                                                                              
echo  
echo     Press any key to continue...
pause > NUL
goto 7M
:6Z
set T4=echo    This batch program is running in "PROTECTED-MODE" MS-DOS, under Windows.  
set T3=::
set T2=::
set T1=echo    It can only be run in "REAL-MODE" MS-DOS (with Windows NOT running).      
set T0=::
set S9=::
set S8=echo                                                                              
set S7=::
set S6=::
goto 7I
:7G
set T4=echo    The operating system, as far as can be determined, is not a version of    
set T3=::
set T2=::
set T1=echo    either Windows 95 or Windows 98.  A version of one of these operating     
set T0=::
set S9=::
set S8=echo    systems is required.                                                      
set S7=::
set S6=::
goto 7I
:7H
set T4=batchman cecho c 0Fh,   There is a problem with the required program:
set T3=batchman cecho c 0Bh,  %Z6%
set T2=batchman cecho 0Fh,%Z5%
set T1=echo    Check that the proper version is installed in one of the system's PATH    
set T0=::
set S9=::
set S8=echo    directories.                                                              
set S7=::
set S6=::
:7I
ctty con
batchman cls 0Fh
echo  Ŀ
echo                                                                           
echo                                              
echo                                             
echo                                               
echo                                                                             
batchman cecho c 0Fh, 
batchman cecho c 0Ch,                              
batchman cecho 0Fh,                                           
batchman cecho c 0Fh, 
batchman cecho c 0Ch,              
batchman cecho 0Fh,                                           
batchman cecho c 0Fh, 
batchman cecho c 0Ch,              
batchman cecho 0Fh,                                            
batchman cecho c 0Fh, 
batchman cecho c 0Ch,              
batchman cecho 0Fh,                                             
echo                                                                              
echo                                                                              
%T4%
%T3%
%T2%
echo                                                                              
%T1%
%T0%
%S9%
echo                                                                              
%S8%
%S7%
%S6%
echo                                                                              
echo                                                                              
batchman cecho c 0Fh,   THIS program (
batchman cecho c 0Bh,9xRamDrv.bat
batchman cecho 0Fh,) must now abort!                               
echo                                                                          :(  
echo                                                                              
echo  
echo     Press any key to continue...
batchman setcursor 26,01
pause > NUL
goto 7K
:7J
mode con: cols=80 lines=50
batchman cls 0Fh
batchman setcursor 50,01
batchman waitfor 01
echo  .                                                                            .  .                                                                            .  .                                                                            .  .                                                                            .  .                                                                            .  .                                                                            .  .                                                                            .  .                                                                            .  .                                                                            .  .                                                                            .  .                                                                            .  .                                                                            .
echo  .                                                                            .  .                                                                            .  .                                                                            .  .                                                                            .  .                                                                            .  .                                                                            .  .                                                                            .  .                                                                            .  .                                                                            .  .                                                                            .  .                                                                            .  .                                                                            .
echo  .                                                                            .  .                                                                            .  .                                                                            .  .                                                                            .  .                                                                            .  .                                                                            .  .                                                                            .  .                                                                            .  .                                                                            .  .                                                                            .  .                                                                            .  .                                                                            .
echo  .                                                                            .  .                                                                            .  .                                                                            .  .                                                                            .  .                                                                            .  .                                                                            .  .                                                                            .  .                                                                            .  .                                                                            .  .                                                                            .  .                                                                            .  .                                                                            .
echo  .                                                                            .  .                                                                            .  .                                                                            .  .                                                                            .  .                                                                            .  .                                                                            .  .                                                                            .  .                                                                            .  .                                                                            .  .                                                                            .  .                                                                            .  .                                                                            .
batchman waitfor 01
echo.
echo  Ŀ
echo  ۳
echo    ۳
echo  Ŀ۰ ۳
echo                         Ŀ  ۳
echo  ۳           ۰ ۳
echo  ۳           ۳
echo  ۳         ۰ ۳
echo  Ŀ                         ۳
echo  ۰ ۳
echo    ۳
echo  ۰ ۳
echo    ۳
echo  ۰ ۳
echo    ۳
echo  ۰ ۳
echo     ۳
echo  ۰   ۳
echo       ۳
echo  ۰    ۳
echo         ۳
echo  ۰      ۳
echo           ۳
echo  ۰       ۳
echo           ۳
echo  ۰       ۳
echo  ۰        ۳
echo  ۰۱       ۳
echo  ۰۱        ۳
echo  ۰۱       ۳
echo  ۰۱        ۳
echo   ۰       ۳
echo           ۳
echo          ۳
echo           ۳
echo    ۱       ۳
echo   ۱        ۳
echo  ۰۱       ۳
echo   ۰        Ŀ۳
echo                                     Ŀ۳
echo          ۳            ۳
echo        ۳          ۳
echo        ۳          ۳
echo     Ŀ                           ۳
echo    ۳
echo   ۳
echo  ۳
echo  
batchman waitfor 05
echo.
echo  .                                                                            .  .                                                                            .  .                                                                            .  .                                                                            .  .                                                                            .  .                                                                            .  .                                                                            .  .                                                                            .  .                                                                            .  .                                                                            .  .                                                                            .  .                                                                            .
echo  .                                                                            .  .                                                                            .  .                                                                            .  .                                                                            .  .                                                                            .  .                                                                            .  .                                                                            .  .                                                                            .  .                                                                            .  .                                                                            .  .                                                                            .  .                                                                            .
echo  .                                                                            .  .                                                                            .  .                                                                            .  .                                                                            .  .                                                                            .  .                                                                            .  .                                                                            .  .                                                                            .  .                                                                            .  .                                                                            .  .                                                                            .  .                                                                            .
echo  .                                                                            .  .                                                                            .  .                                                                            .  .                                                                            .  .                                                                            .  .                                                                            .  .                                                                            .  .                                                                            .  .                                                                            .  .                                                                            .  .                                                                            .  .                                                                            .
echo  .                                                                            .  .                                                                            .  .                                                                            .  .                                                                            .  .                                                                            .  .                                                                            .  .                                                                            .  .                                                                            .  .                                                                            .  .                                                                            .  .                                                                            .  .                                                                            .
batchman waitfor 01
for %%S in (. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .) do echo%%S
mode con: cols=80 lines=25
:7K
ctty nul
if .%Z9%%Z8%.==.8025. goto 7L
mode con: cols=%Z9% lines=%Z8%
:7L
for %%T in (Z9 Z8 Z7 Z6 Z5 Z4 Z3 Z2 Z1 Z0 RFN) do set %%T=
for %%U in (Y9 Y8 Y7 Y6 Y5 Y4 Y3 Y2 Y1 Y0 X9 X8 X7 X6 X5 X4 X3 X2 X1 X0 W9 W8 W7 W6 W5 W4 W3 W2 W1 W0 V9 V8) do set %%U=
for %%V in (V7 V6 V5 V4 V3 V2 V1 V0 U9 U8 U7 U6 U5 U4 U3 U2 U1 U0 T9 T8 T7 T6 T5 T4 T3 T2 T1 T0 S9 S8 S7 S6) do set %%V=
ctty con
:7M
cls
:END